/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.readers.ReadVTK;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.swingwrappers.TextField;
import static org.visnow.vn.lib.basic.readers.ReadVTK.ReadVTKShared.*;
import org.visnow.vn.system.main.VisNow;

/**
 * @author Bartosz Borucki (babor@icm.edu.pl) Warsaw University,
 * Interdisciplinary Centre for Mathematical and Computational Modelling
 */
public class GUI extends javax.swing.JPanel
{
    private final JFileChooser fileChooser = new JFileChooser();
    private final FileFilter[] filters = new FileFilter[]{
        new FileNameExtensionFilter("All VTK files", "vtk", "VTK", "vtp", "VTP", "vtu", "VTU", "vtm", "VTM"),
        new FileNameExtensionFilter("Legacy VTK files  (*.vtk)", "vtk", "VTK"),
        new FileNameExtensionFilter("XML polydata files  (*.vtp)", "vtp", "VTP"),
        new FileNameExtensionFilter("XML unstructured grid files  (*.vtu)", "vtu", "VTU"),
        new FileNameExtensionFilter("XML multi block files  (*.vtm)", "vtm", "VTM")};

    private String lastPath = null;
    private Parameters parameters;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
        for (FileFilter filter : filters)
            fileChooser.addChoosableFileFilter(filter);

        fileChooser.setFileFilter(filters[0]);
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    protected void updateGUI(final ParameterProxy p)
    {
        fileNameTF.setText(p.get(FILENAME));
        bigEndianRB.setSelected(p.get(BIG_ENDIAN));
        littleEndianRB.setSelected(!p.get(BIG_ENDIAN));
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        endiannessBG = new javax.swing.ButtonGroup();
        browsePanel = new javax.swing.JPanel();
        fileNameTF = new org.visnow.vn.gui.swingwrappers.TextField();
        browseButton = new javax.swing.JButton();
        endiannessPanel = new javax.swing.JPanel();
        bigEndianRB = new org.visnow.vn.gui.swingwrappers.RadioButton();
        littleEndianRB = new org.visnow.vn.gui.swingwrappers.RadioButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setBorder(javax.swing.BorderFactory.createEmptyBorder(4, 4, 4, 4));
        setName(""); // NOI18N
        setRequestFocusEnabled(false);
        setLayout(new java.awt.GridBagLayout());

        browsePanel.setLayout(new java.awt.GridBagLayout());

        fileNameTF.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                fileNameTFUserAction(evt);
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        browsePanel.add(fileNameTF, gridBagConstraints);

        browseButton.setText("Browse...");
        browseButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                browseButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 8, 0, 0);
        browsePanel.add(browseButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(browsePanel, gridBagConstraints);

        endiannessPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 4, 4));

        endiannessBG.add(bigEndianRB);
        bigEndianRB.setText("big endian");
        bigEndianRB.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                endianRBChange(evt);
            }
        });
        endiannessPanel.add(bigEndianRB);

        endiannessBG.add(littleEndianRB);
        littleEndianRB.setText("little endian");
        littleEndianRB.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                endianRBChange(evt);
            }
        });
        endiannessPanel.add(littleEndianRB);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(endiannessPanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void fileNameTFUserAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_fileNameTFUserAction
    {//GEN-HEADEREND:event_fileNameTFUserAction
        if (evt.getEventType() == TextField.EVENT_CHANGE_VALUE || evt.getEventType() == TextField.EVENT_NO_CHANGE_ENTER_KEY)
            parameters.set(FILENAME, fileNameTF.getText());
    }//GEN-LAST:event_fileNameTFUserAction

    private void browseButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_browseButtonActionPerformed
    {//GEN-HEADEREND:event_browseButtonActionPerformed
        fileChooser.setCurrentDirectory(new File(VisNow.get().getMainConfig().getUsableDataPath(ReadVTK.class)));

        if (fileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            String path = fileChooser.getSelectedFile().getAbsolutePath();
            VisNow.get().getMainConfig().setLastDataPath(path.substring(0, path.lastIndexOf(File.separator)), ReadVTK.class);
            fileNameTF.setText(path);
            parameters.set(FILENAME, path);
        }
    }//GEN-LAST:event_browseButtonActionPerformed

    private void endianRBChange(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_endianRBChange
    {//GEN-HEADEREND:event_endianRBChange
        parameters.set(BIG_ENDIAN, bigEndianRB.isSelected());
    }//GEN-LAST:event_endianRBChange

    public void activateOpenDialog()
    {
        browseButtonActionPerformed(null);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.gui.swingwrappers.RadioButton bigEndianRB;
    private javax.swing.JButton browseButton;
    private javax.swing.JPanel browsePanel;
    private javax.swing.ButtonGroup endiannessBG;
    private javax.swing.JPanel endiannessPanel;
    private org.visnow.vn.gui.swingwrappers.TextField fileNameTF;
    private javax.swing.Box.Filler filler1;
    private org.visnow.vn.gui.swingwrappers.RadioButton littleEndianRB;
    // End of variables declaration//GEN-END:variables

}
